
--
-- Create schema banque
--

CREATE DATABASE IF NOT EXISTS banque;
USE banque;

--
-- Definition of table `agence`
--

DROP TABLE IF EXISTS `agence`;
CREATE TABLE `agence` (
  `codeag` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nomag` varchar(50) NOT NULL,
  `adresseag` varchar(100) NOT NULL,
  PRIMARY KEY (`codeag`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `agence`
--

/*!40000 ALTER TABLE `agence` DISABLE KEYS */;
INSERT INTO `agence` (`codeag`,`nomag`,`adresseag`) VALUES 
 (10,'CBAO Aline Sitoe','33 sotrac Mermoz'),
 (11,'CBAO Plataux','Plataux rue 24');
/*!40000 ALTER TABLE `agence` ENABLE KEYS */;


--
-- Definition of table `client`
--

DROP TABLE IF EXISTS `client`;
CREATE TABLE `client` (
  `codecli` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nomcli` varchar(25) NOT NULL,
  `prenomcli` varchar(50) NOT NULL,
  `adressecli` varchar(100) NOT NULL,
  `codeag` int(10) unsigned NOT NULL,
  PRIMARY KEY (`codecli`),
  KEY `codeag` (`codeag`),
  CONSTRAINT `codeag` FOREIGN KEY (`codeag`) REFERENCES `agence` (`codeag`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `client`
--

/*!40000 ALTER TABLE `client` DISABLE KEYS */;
INSERT INTO `client` (`codecli`,`nomcli`,`prenomcli`,`adressecli`,`codeag`) VALUES 
 (7,'Diallo','Samassa','Ouakam rue 23',10),
 (8,'Fall','Moustafa','Dakar Medina',11);
/*!40000 ALTER TABLE `client` ENABLE KEYS */;


--
-- Definition of table `compte`
--

DROP TABLE IF EXISTS `compte`;
CREATE TABLE `compte` (
  `codecpt` varchar(50) NOT NULL,
  `libcpt` varchar(100) NOT NULL,
  `senscpt` varchar(2) NOT NULL,
  `soldcpt` int(10) unsigned NOT NULL,
  `codecli` int(10) unsigned NOT NULL,
  PRIMARY KEY (`codecpt`),
  KEY `codecli` (`codecli`),
  CONSTRAINT `codecli` FOREIGN KEY (`codecli`) REFERENCES `client` (`codecli`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `compte`
--

/*!40000 ALTER TABLE `compte` DISABLE KEYS */;
INSERT INTO `compte` (`codecpt`,`libcpt`,`senscpt`,`soldcpt`,`codecli`) VALUES 
 ('47466774','Personnel','DB',1170000,7);
/*!40000 ALTER TABLE `compte` ENABLE KEYS */;


--
-- Definition of table `operation`
--

DROP TABLE IF EXISTS `operation`;
CREATE TABLE `operation` (
  `numop` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `libop` varchar(100) NOT NULL,
  `sensop` varchar(2) NOT NULL,
  `montantop` int(10) unsigned NOT NULL,
  `dateop` datetime NOT NULL,
  `codecpt` varchar(50) NOT NULL,
  PRIMARY KEY (`numop`),
  KEY `codecpt` (`codecpt`),
  CONSTRAINT `codecpt` FOREIGN KEY (`codecpt`) REFERENCES `compte` (`codecpt`)
) ENGINE=InnoDB AUTO_INCREMENT=26 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `operation`
--

/*!40000 ALTER TABLE `operation` DISABLE KEYS */;
INSERT INTO `operation` (`numop`,`libop`,`sensop`,`montantop`,`dateop`,`codecpt`) VALUES 
 (24,'Ouverture de compte','DB',1200000,'2012-07-14 23:44:31','47466774'),
 (25,'retrai','DB',30000,'2012-07-15 01:07:35','47466774');
/*!40000 ALTER TABLE `operation` ENABLE KEYS */;




